// rddecvw.cpp : implementation of the CRddeclntView class
//

#include "stdafx.h"

#include "rddecdoc.h"
#include "rddecvw.h"
#include "rddeclnt.h"

#include "rddedlg.h"
#include "advisedl.h"
#include "cancelad.h"

#include <stdlib.h>

#ifdef _DEBUG
#undef THIS_FILE
static char BASED_CODE THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CRddeclntView

IMPLEMENT_DYNCREATE(CRddeclntView, CScrollView)

BEGIN_MESSAGE_MAP(CRddeclntView, CScrollView)
	//{{AFX_MSG_MAP(CRddeclntView)
	ON_WM_CHAR()
	ON_WM_RBUTTONDBLCLK()
	ON_COMMAND(ID_CONNECT, OnConnect)
	ON_COMMAND(ID_ADVISE, OnAdvise)
	ON_COMMAND(ID_CANCEL_ADVISE, OnCancelAdvise)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CRddeclntView construction/destruction

CRddeclntView::CRddeclntView()
{
	// TODO: add construction code here
   pView = this;
}

CRddeclntView::~CRddeclntView()
{
}

void CRddeclntView::OnInitialUpdate()
{
   CScrollView::OnInitialUpdate();

   SetScrollSizes(MM_TEXT, CSize(10,10));
}

/////////////////////////////////////////////////////////////////////////////
// CRddeclntView drawing

void CRddeclntView::OnDraw(CDC* pDC)
{
   CRddeclntDoc* pDoc = GetDocument();
   pDocument = pDoc;
   ASSERT_VALID(pDoc);

   // Change to the system fixed font
   CFont *pOldFont = (CFont*) pDC->SelectStockObject(SYSTEM_FIXED_FONT);
   
   // TODO: add draw code for native data here
   CString& data = pDoc->GetDDEdata();
   LPCSTR pc = (LPCSTR)data;
   int x = 8, y = 10, nc = data.GetLength();

   // Get the document size
   int MaxX = pDoc->m_DocumentSize.cx;
   int MaxY = pDoc->m_DocumentSize.cy;

// Compute the line height based on current font
   TEXTMETRIC tm;
   pDC->GetTextMetrics(&tm);
   int line_height = tm.tmHeight + tm.tmExternalLeading;
   
   int np = 0, nl = 0;

// Find out if the botton of the document is visible
   RECT ViewArea;
   GetClientRect( &ViewArea );
   CPoint ScrollPosition = GetScrollPosition();
   BOOL BottomVisible = ScrollPosition.y + ViewArea.bottom >= MaxY;

// pc points to the next part of the buffer to be displayed
// nl is the number of characters to display in one TextOut() call
// nc is the total number of characters in the buffer
// np is the index in the buffer of the next part to be displayed

   while(np < nc)
   {

// Here begins a new line of text. Do a TextOut() whenever we get
// to a newline or tab.

      for ( nl = 0; nl <= nc-np; nl++ )
      {
         if(pc[nl] == '\t')
         {
            pDC->TextOut(x, y, pc, nl);
            x += nl * tm.tmAveCharWidth;
            pDC->TextOut(x, y, "    ", 4);
            x += 4 * tm.tmAveCharWidth;
            if ( x > MaxX )
               MaxX = x;
            nl++; //Skip the tab character so pointers start after it
            np += nl;
            pc = &pc[nl];
            break;
         }
         if( nl == nc-np || pc[nl] == '\r' || pc[nl] == '\n')
         {
            pDC->TextOut(x, y, pc, nl);
            x += nl * tm.tmAveCharWidth;
            if ( x > MaxX )
               MaxX = x;
            x = 8;
            y += line_height;
            if ( y > MaxY )
               MaxY = y;
            nl++;

// Skip the linefeed (\n) following a carriage-return (\r) 
            if(nl < nc-np-1 && pc[nl-1] == '\r' &&
               pc[nl] == '\n') nl++;

            np += nl;
            pc = &pc[nl];
            break;
         }
         // Otherwise just count the length of the section
      }
   }

   // Restore the font
   pDC->SelectObject(pOldFont);

   // Set the document size. Allow for the last text with no newline
   pDoc->m_DocumentSize.cx = MaxX;
   pDoc->m_DocumentSize.cy = MaxY;

   
   // Pass in the total size calculated when text is added
   // Horizontal scroll is 1 or 10 characters.
   // Vertical scroll is 1 line or a screen full - 2 lines
   CSize PageScroll(10*tm.tmAveCharWidth,
                    ViewArea.bottom - 2*line_height);
   CSize LineScroll(tm.tmAveCharWidth, line_height);
   CScrollView::SetScrollSizes(MM_TEXT, pDoc->m_DocumentSize,
                               PageScroll, LineScroll);

 // If the bottom line is visible scroll down a line
   if ( BottomVisible && MaxY > ViewArea.bottom )
   {
      ScrollPosition.y = MaxY - ViewArea.bottom;
      ScrollToPosition( ScrollPosition );
   }
}
   
/////////////////////////////////////////////////////////////////////////////
// Paint a single line. The caller has put the text into the document

void CRddeclntView::PaintLine(WORD RowNumber, const char *pData)
{
   CDC *pDC = GetDC();

   OnPrepareDC(pDC, NULL);
   // Change to the system fixed font
   CFont *pOldFont = (CFont*) pDC->SelectStockObject(SYSTEM_FIXED_FONT);
   
   // Compute the line height based on current font
   TEXTMETRIC tm;
   pDC->GetTextMetrics(&tm);
   int line_height = tm.tmHeight + tm.tmExternalLeading;
   
   pDC->TextOut(8, 10+(line_height*RowNumber), pData, strlen(pData));

   // Restore the font
   pDC->SelectObject(pOldFont);

   ReleaseDC(pDC);
}

/////////////////////////////////////////////////////////////////////////////
// CRddeclntView diagnostics

#ifdef _DEBUG
void CRddeclntView::AssertValid() const
{
	CScrollView::AssertValid();
}

void CRddeclntView::Dump(CDumpContext& dc) const
{
	CScrollView::Dump(dc);
}

CRddeclntDoc* CRddeclntView::GetDocument() // non-debug version is inline
{
	ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(CRddeclntDoc)));
	return (CRddeclntDoc*)m_pDocument;
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CRddeclntView message handlers

void CRddeclntView::OnChar(UINT nChar, UINT nRepCnt, UINT nFlags)
{
	// TODO: Add your message handler code here and/or call default
	if ( toupper(nChar) == 'C' )
		CRddeclntView::OnConnect();
	else
		CScrollView::OnChar(nChar, nRepCnt, nFlags);
}

void CRddeclntView::OnRButtonDblClk(UINT nFlags, CPoint point)
{
	// TODO: Add your message handler code here and/or call default
	
	CRddeclntView::OnConnect();
}

void CRddeclntView::OnConnect()
{
	// TODO: Add your command handler code here
// Display the "Connect to DDE Server" dialog
    CRDDEDlg dlg;

    int status = dlg.DoModal();
    if(status == IDOK)
    {
       CRddeclntDoc* pDoc = GetDocument();
       pDocument = pDoc;

       ASSERT_VALID(pDocument);
       pDocument->DoDDE(dlg.m_Service,
                        dlg.m_Item, dlg.m_MessageBoxes);
       pDocument->UpdateAllViews(NULL);
    }
}


void CRddeclntView::OnAdvise()
{
	// TODO: Add your command handler code here
// Display the "New advise" dialog
    CAdviseDlg dlg;

    int status = dlg.DoModal();
    if(status == IDOK)
    {
       CRddeclntDoc* pDoc = GetDocument();
       pDocument = pDoc;

       ASSERT_VALID(pDocument);
       pDocument->DoNewAdvise(dlg.m_ItemString, dlg.m_MessageBoxes);
       pDocument->UpdateAllViews(NULL);
   }	
}

void CRddeclntView::OnCancelAdvise()
{
	// TODO: Add your command handler code here
// Display the "New advise" dialog
    CCancelAdviseDlg dlg;

    int status = dlg.DoModal();
    if(status == IDOK)
    {
       CRddeclntDoc* pDoc = GetDocument();
       pDocument = pDoc;

       ASSERT_VALID(pDocument);
       pDocument->DoCancelAdvise(dlg.m_ItemString);
       pDocument->UpdateAllViews(NULL);
   }	
}
